# coding: utf-8

# flake8: noqa
"""
    RAGsys API

     RAGSys API is an innovative AI retrieval engine developed by Crossing Minds to enhance  Large Language Model (LLM) performance without the need for traditional fine-tuning.  By integrating Retrieval-Augmented Generation (RAG) techniques, RAGSys enables seamless adaptation  of LLMs to various tasks and domains, offering a cost-effective and scalable solution for  enterprises.   Key Features of RAGSys:  - **Seamless Integration**: Compatible with any LLM, including those from Anthropic, OpenAI, and open-source alternatives, allowing effortless switching between models without losing optimizations.  - **Enhanced Retrieval with RAG Embeddings**: Utilizes proprietary RAG embeddings to ensure better understanding and rapid information retrieval, even with massive datasets, resulting in more contextually relevant and accurate LLM outputs.  - **Groundbreaking Accuracy Improvements**: Consistently outperforms traditional fine-tuning, achieving up to a 76% improvement on key benchmarks, with significant enhancements in truthfulness, emotion detection, and commonsense reasoning across various LLMs.  - **Scalable Architecture**: Designed for enterprise-scale deployment, efficiently handling large datasets and complex retrieval tasks, ensuring consistent performance as AI needs grow.   By leveraging RAGSys, organizations can rapidly adapt LLMs to new tasks or domains, saving computational resources and accelerating deployment cycles, all while maintaining high levels of accuracy and relevance in AI outputs.  

    The version of the OpenAPI document: 1.0.0
    Contact: contact@crossingminds.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


# import models into model package
from ragsys.models.choice import Choice
from ragsys.models.completion_body import CompletionBody
from ragsys.models.completion_response import CompletionResponse
from ragsys.models.content import Content
from ragsys.models.content_item import ContentItem
from ragsys.models.content_item_type import ContentItemType
from ragsys.models.create_database_request import CreateDatabaseRequest
from ragsys.models.create_or_partial_update_examples_response import CreateOrPartialUpdateExamplesResponse
from ragsys.models.database_item import DatabaseItem
from ragsys.models.database_list_response import DatabaseListResponse
from ragsys.models.example import Example
from ragsys.models.example_response import ExampleResponse
from ragsys.models.examples_body import ExamplesBody
from ragsys.models.examples_response import ExamplesResponse
from ragsys.models.get_configuration_response import GetConfigurationResponse
from ragsys.models.http_validation_error import HTTPValidationError
from ragsys.models.image_url import ImageUrl
from ragsys.models.init_database_response import InitDatabaseResponse
from ragsys.models.llm_list_models_response import LlmListModelsResponse
from ragsys.models.message_completion_content import MessageCompletionContent
from ragsys.models.message_content import MessageContent
from ragsys.models.message_role import MessageRole
from ragsys.models.retrieval import Retrieval
from ragsys.models.retrieve_examples import RetrieveExamples
from ragsys.models.retrieve_examples_response import RetrieveExamplesResponse
from ragsys.models.task_response import TaskResponse
from ragsys.models.task_type import TaskType
from ragsys.models.task_with_details_response import TaskWithDetailsResponse
from ragsys.models.update_database import UpdateDatabase
from ragsys.models.usage import Usage
from ragsys.models.validation_error import ValidationError
from ragsys.models.validation_error_loc_inner import ValidationErrorLocInner
