# coding: utf-8

"""
    RAGsys API

     RAGSys API is an innovative AI retrieval engine developed by Crossing Minds to enhance  Large Language Model (LLM) performance without the need for traditional fine-tuning.  By integrating Retrieval-Augmented Generation (RAG) techniques, RAGSys enables seamless adaptation  of LLMs to various tasks and domains, offering a cost-effective and scalable solution for  enterprises.   Key Features of RAGSys:  - **Seamless Integration**: Compatible with any LLM, including those from Anthropic, OpenAI, and open-source alternatives, allowing effortless switching between models without losing optimizations.  - **Enhanced Retrieval with RAG Embeddings**: Utilizes proprietary RAG embeddings to ensure better understanding and rapid information retrieval, even with massive datasets, resulting in more contextually relevant and accurate LLM outputs.  - **Groundbreaking Accuracy Improvements**: Consistently outperforms traditional fine-tuning, achieving up to a 76% improvement on key benchmarks, with significant enhancements in truthfulness, emotion detection, and commonsense reasoning across various LLMs.  - **Scalable Architecture**: Designed for enterprise-scale deployment, efficiently handling large datasets and complex retrieval tasks, ensuring consistent performance as AI needs grow.   By leveraging RAGSys, organizations can rapidly adapt LLMs to new tasks or domains, saving computational resources and accelerating deployment cycles, all while maintaining high levels of accuracy and relevance in AI outputs.  

    The version of the OpenAPI document: 1.0.0
    Contact: contact@crossingminds.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from ragsys.api.few_shot_example_api import FewShotExampleApi


class TestFewShotExampleApi(unittest.TestCase):
    """FewShotExampleApi unit test stubs"""

    def setUp(self) -> None:
        self.api = FewShotExampleApi()

    def tearDown(self) -> None:
        pass

    def test_get_saved_examples(self) -> None:
        """Test case for get_saved_examples

        Get Saved Examples
        """
        pass

    def test_retrieve_ranked_examples(self) -> None:
        """Test case for retrieve_ranked_examples

        Rank Examples With Retrieval Model
        """
        pass

    def test_save_examples(self) -> None:
        """Test case for save_examples

        Save Examples
        """
        pass


if __name__ == '__main__':
    unittest.main()
